#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

const int MAX = 1000;

int X[MAX];
int Y[MAX];
int YC[MAX];

bool gonderebilir[MAX][MAX];

int dfs(int suan, vector<bool>& iletir, int n) {
    if (iletir[suan]) {
        return 0;
    }

    iletir[suan] = true;
    int cvp = 1;

    for (int i = 0; i < n; ++i)
        if (gonderebilir[suan][i])
            cvp += dfs(i, iletir, n);

    return cvp;
}

int main() {

    int N;
    cin >> N;

    for (int i = 0; i < N; ++i)
        cin >> X[i] >> Y[i] >> YC[i];

    for (int i = 0; i < N; ++i)
        for (int j = 0; j < N; ++j) {
            int uzaklik = (X[i] - X[j]) * (X[i] - X[j]) + (Y[i] - Y[j]) * (Y[i] - Y[j]);
            if (uzaklik <= YC[i] * YC[i]) 
                gonderebilir[i][j] = true;
        }
   

    int cvp = 1;

    for (int i = 0; i < N; ++i) {
        vector<bool> iletir(N, false);
        cvp = max(cvp, dfs(i, iletir, N));
    }

    cout << cvp << endl;

    return 0;
}

