//#include "bits/stdc++.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

#define pb push_back

const int MAX = 1e5+5;

int N, alt[MAX], cur[MAX];

vector<int> komsuluk[MAX], num[MAX];

bool bad = 0;
 
void dfs(int a, int b) {
	alt[a] = 1;
	for(int& t: komsuluk[a]) 
	 if (t != b) {
		dfs(t,a);
		alt[a] += alt[t];
		num[a].pb(alt[t]);
	 }
	if (alt[a] != N) 
		num[a].pb(N-alt[a]);
}
 
bool ok(int K) {
	if ((N-1) % K != 0) 
		return 0;

	for (int i = 0; i < K; ++i) 
		cur[i] = 0;

	for (int i = 1; i <= N; ++i) {
		int sayi = 0;
		for (int& t: num[i]) {
			int z = t % K; 
			if (z == 0) continue;
			if (cur[K-z]) {
				cur[K-z]--; 
				sayi--;
			}
			else {
				cur[z]++; 
				sayi++;
			}
		}
		if (sayi) 
			return 0; 
	}
	return 1;
}
 
int main() {
	cin >> N;

	for (int i = 1; i < N; ++i) {
		int a,b; cin >> a >> b;
		komsuluk[a].pb(b); 
		komsuluk[b].pb(a);
	}

	dfs(1,0);

	for (int i = 1; i < N; ++i) {
		if (ok(i)) cout << 1;
		else cout << 0;
	}
	cout << endl;
}
